require 'rails_bundle_tools'

# There is a bug in the action_name method. If it is called and the textmate cursor
# isn't actually in an action, it will throw an exception when it probably should
# return nil. It also needs to be extended to support more file types
class RailsPath
  def action_name
    name =
      case file_type
      when :controller, :model
        buffer.find_method(:direction => :backwards).first rescue nil
      when :view
        basename
      when :functional_test, :unit_test
        buffer.find_method(:direction => :backwards).first.sub('^test_', '')
      else nil
      end

    return name.sub(/\.\w+$/, '') rescue nil # Remove extension
  rescue
    nil
  end
end

def get_arguments(current_file)
  if action_name = current_file.action_name
    "-n #{current_file.action_name}"
  else
    ""
  end
end

Dir.chdir ENV['TM_PROJECT_DIRECTORY']

current_file = RailsPath.new

command = case current_file.file_type
            when :controller then "ruby #{current_file.rails_path_for(:functional_test).filepath}"
            when :model then "ruby #{current_file.rails_path_for(:unit_test).filepath}"
            when :functional_test, :unit_test then "ruby #{current_file.filepath} #{get_arguments current_file}"
          end
          
output  = `#{command}`
puts "<pre>#{output}</pre>"